Show: Inherited Protected Private Deprecated

# ButtonLinkTargetEdit Class

Uses:

- WidgetFocusManager

Defined in: `src/ui/react/src/components/buttons/button-link-target-edit.jsx:4`

The ButtonLinkTargetEdit class provides functionality for changing the target of a link in the document.

## Index

### Methods

- _getAllowedTargetsList
- _getAllowedTargetsListItems
- _getFocusAction
- _getFocusDismissAction
- _getFocusMoveDirection
- _isValidKey
- _moveFocus
- _refresh
- componentDidMount
- componentDidUpdate
- focus
- getDefaultProps
- handleKey
- moveFocus
- render

### Properties

- allowedTargets
- circular
- descendants
- editor
- key static
- keys
- onDismiss
- selectedTarget

## Methods

### `_getAllowedTargetsList`

() Object protected

Defined in `src/ui/react/src/components/buttons/button-link-target-edit.jsx:98`

Creates the dropdown list of allowed link targets.

#### Returns:

Object:

The allowed targets dropdown.

### `_getAllowedTargetsListItems`

() Array protected

Defined in `src/ui/react/src/components/buttons/button-link-target-edit.jsx:114`

Creates the allowed link target items.

#### Returns:

Array:

The allowed target items.

### `_getFocusAction`

(

- `event`

)
Object protected

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:134`

Returns the action, if any, that a keyboard event in the current focus manager state should produce.

#### Parameters:

- `event` Object

  The Keyboard event.

#### Returns:

Object:

An action object with type and direction properties.

### `_getFocusDismissAction`

(

- `event`
- `focusMoveDirection`

)
Object protected

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:167`

Returns the dismiss action, if any, the focus manager should execute to yield the focus. This will happen in any of these scenarios if a dismiss callback has been specified:

- A dismiss key has been pressed
- In a non-circular focus manager, when:
  - The active descendant is the first one and a prev key has been pressed.
  - The active descendant is the last one and a next key has been pressed.

#### Parameters:

- `event` Object

  The Keyboard event.

- `focusMoveDirection` Number

  The focus movement direction (if any).

#### Returns:

Object:

A dismiss action with dismiss and direction properties.

### `_getFocusMoveDirection`

(

- `event`

)
Number protected

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:211`

Returns the direction, if any, in which the focus should be moved. In presence of the shift key modifier, the direction of the movement is inverted.

#### Parameters:

- `event` Object

  The Keyboard event.

#### Returns:

Number:

The computed direction of the expected focus movement.

### `_isValidKey`

(

- `keyCode`
- `keys`

)
Boolean protected

Inherited from WidgetFocusManager but overwritten in `src/ui/react/src/components/base/widget-focus-manager.js:237`

Indicates if a given keyCode is valid for the given set of keys.

#### Parameters:

- `keyCode` Number

  An event keyCode.

- `keys` Array | Number

  A key set. Can be a number an array of numbers representing the allowed keyCodes.

#### Returns:

Boolean:

A boolean value indicating if the key is valid.

### `_moveFocus`

(

- `direction`

)
protected

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:266`

Moves the focus among descendants in the especified direction.

#### Parameters:

- `direction` Number

  The direction (1 or -1) of the focus movement among descendants.

### `_refresh`

() protected

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:296`

Refreshes the descendants list by executing the CSS selector again and resets the descendants tabIndex.

### `componentDidMount`

()

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:57`

Lifecycle. Invoked once, only on the client, immediately after the initial rendering occurs.

### `componentDidUpdate`

()

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:66`

Lifecycle. Invoked immediately after the component's updates are flushed to the DOM. Refreshes the descendants list.

### `focus`

()

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:76`

Focuses the current active descendant.

Several Widgets can be nested in a component hierarchy by attaching this focus method to the widget DOM node, transferring the DOM focus control to the inner FocusManager.

### `getDefaultProps`

()

Defined in `src/ui/react/src/components/buttons/button-link-target-edit.jsx:53`

Lifecycle. Returns the default values of the properties used in the widget.

### `handleKey`

(

- `event`

)

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:97`

Handles the key events on a DOM node to execute the appropriate navigation when needed.

#### Parameters:

- `event` Object

  The Keyboard event that was detected on the widget DOM node.

### `moveFocus`

(

- `direction`

)

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:122`

Moves the focus among descendants in the especified direction.

#### Parameters:

- `direction` Number

  The direction (1 or -1) of the focus movement among descendants.

### `render`

() Object

Defined in `src/ui/react/src/components/buttons/button-link-target-edit.jsx:72`

Lifecycle. Renders the UI of the button.

#### Returns:

Object:

The content which should be rendered.

## Properties

### `allowedTargets`

Array

Defined in `src/ui/react/src/components/buttons/button-link-target-edit.jsx:17`

List of the allowed items for the target attribute. Every allowed target is an object with a `label` attribute that will be shown in the dropdown and a `value` attribute that will get set as the link target attribute.

### `circular`

Boolean

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:33`

Indicates if focus should be set to the first/last descendant when the limits are reached.

### `descendants`

String

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:40`

String representing the CSS selector used to define the elements that should be handled.

### `editor`

Object

Defined in `src/ui/react/src/components/buttons/button-link-target-edit.jsx:26`

The editor instance where the component is being used.

### `key`

String static

Defined in `src/ui/react/src/components/buttons/button-link-target-edit.jsx:43`

The name which will be used as an alias of the button in the configuration.

Default: linkTargetEdit

### `keys`

Object

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:47`

Object representing the keys used to navigate between descendants. The format for the prop is: `{dismiss: value, dismissNext: value, dismissPrev: value, next: value, prev: value}` where value can be both a number or an array of numbers with the allowed keyCodes.

### `onDismiss`

Function

Inherited from WidgetFocusManager: `src/ui/react/src/components/base/widget-focus-manager.js:21`

Callback method to be invoked when the focus manager is to be dismissed. This happens in the following scenarios if a dismiss callback has been specified:

- A dismiss key has been pressed
- In a non-circular focus manager, when:
  - The active descendant is the first one and a prev key has been pressed.
  - The active descendant is the last one and a next key has been pressed.

### `selectedTarget`

String

Defined in `src/ui/react/src/components/buttons/button-link-target-edit.jsx:33`

Label of the current target value.